<template>
  <el-select
    @change="change"
    @blur="$emit('blur')"
    :value="value"
    :placeholder="placeholder"
    :remote-method="filter"
    remote
    filterable
    clearable
  >
    <el-option
      v-for="option in options"
      :key="option._id"
      :label="option[searchFieldName]"
      :value="option._id" />
  </el-select>
</template>

<script>
export default {
  name: "app-select-related",
  props: {
    value: { type: String, required: true, default: "" },
    placeholder: { type: String, required: false },
    service: { type: Object, required: true },
    searchFieldName: { type: String, required: true }
  },
  data() {
    return {
      options: []
    };
  },
  watch: {
    value: async function(newValue) {
      if (this.value && this.options.length === 0) {
        this.options = [await this.service.get(this.value)];
      }
    }
  },
  methods: {
    async filter(filterString) {
      const query = {
        [this.searchFieldName]: { $search: filterString }
      };
      const clients = await this.service.find({ query });
      this.options = clients.data;
    },
    getLabel(option) {
      return option[this.searchFieldName];
    },
    change(newValue) {
      this.$emit("input", newValue);
    }
  }
};
</script>
